<?php
/**
 * @version		$Id: article.php 11646 2009-03-01 19:34:56Z ian $
 * @package		Joomla
 * @subpackage	Content
 * @copyright	Copyright (C) 2005 - 2008 Open Source Matters. All rights reserved.
 * @license		GNU/GPL, see LICENSE.php
 * Joomla! is free software. This version may have been modified pursuant to the
 * GNU General Public License, and as distributed it includes or is derivative
 * of works licensed under the GNU General Public License or other free or open
 * source software licenses. See COPYRIGHT.php for copyright notices and
 * details.
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die( 'Restricted access' );

jimport('joomla.application.component.model');

/**
 * Content Component Article Model
 *
 * @package		Joomla
 * @subpackage	Content
 * @since 1.5
 */
class Community_stuffsModelStuff_details extends JModel
{
	function Community_stuffsModelStuff_details()
	{
		parent::__construct();
	}

	function getStuffDetails($stid) 
	{
		$db = &JFactory::getDBO();
		$query = 'SELECT sn.*, st.price, st.note, st.type, st.picture, st.user_id '
				.'FROM #__community_stuffs AS st '
				.'LEFT JOIN #__community_stuff_names AS sn ON st.stuff_name_id=sn.id '
				.'WHERE st.id='.$stid;
		$db->setQuery($query);
		$obj = $db->loadObject();
		return $obj;
	}

	function getTypeNames() {
		$db = &JFactory::getDBO();
		$db->setQuery("SELECT params FROM #__plugins WHERE element='community_stuffs'");
		$prs = $db->loadResult();
		$tn[0] = JText::_('TYPE0');
		preg_match("/(type1)=([^\n]*\n)/", $prs, $m);
		$tn[1] = $m[2];
		preg_match("/(type2)=([^\n]*\n)/", $prs, $m);
		$tn[2] = $m[2];
		preg_match("/(type3)=([^\n]*\n)/", $prs, $m);
		$tn[3] = $m[2];
		preg_match("/(type4)=([^\n]*\n)/", $prs, $m);
		$tn[4] = $m[2];
		return $tn;
	}
	
}
