<?php
/**
 * @version		$Id: view.html.php 11665 2009-03-08 20:30:23Z willebil $
 * @package		Joomla
 * @subpackage	Contact
 * @copyright	Copyright (C) 2005 - 2008 Open Source Matters. All rights reserved.
 * @license		GNU/GPL, see LICENSE.php
 * Joomla! is free software. This version may have been modified pursuant to the
 * GNU General Public License, and as distributed it includes or is derivative
 * of works licensed under the GNU General Public License or other free or open
 * source software licenses. See COPYRIGHT.php for copyright notices and
 * details.
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die( 'Restricted access' );

jimport('joomla.application.component.view');

/**
 * @package		Joomla
 * @subpackage	Contacts
 */
class Community_stuffsViewStuff_details extends JView
{
	function display($tpl = null)
	{
		$model	  = &$this->getModel();

		$doc = & JFactory::getDocument();		
		$doc->addStyleSheet(JURI::root().'components/com_community_stuffs/shadowstyle.css');

		// Selected Request vars
		$stid				= JRequest::getVar('stid',				-1,				'', 'int');		

		jimport('joomla.filesystem.file');
		$params = new JParameter(JFile::read(JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_community'.DS.'config.ini'));
		$src = JURI::root().$params->get('general::upload');
	
		$this->assign('stuff',		$model->getStuffDetails($stid));
		$this->assign('tn',			$model->getTypeNames());
		$this->assign('src',		$src);

		parent::display($tpl);
	}
}
